com.amazonaws.codegen.model.intermediate

## Class ShapeModel

- java.lang.Object
- - com.amazonaws.codegen.model.intermediate.DocumentationModel
  - - com.amazonaws.codegen.model.intermediate.ShapeModel

    public class ShapeModel
    extends DocumentationModel

### Field Summary

### Fields inherited from class com.amazonaws.codegen.model.intermediate.DocumentationModel

`documentation`

### Constructor Summary

Constructors
Constructor and Description
`ShapeModel(String c2jName)`

### Method Summary

All Methods Instance Methods Concrete Methods
`void` `addConstructor(ConstructorModel constructor)`
`void` `addEnum(EnumModel enumModel)`
`void` `addMember(MemberModel member)`
`EnumModel` `findEnumModelByValue(String enumValue)` Returns the enum model for the given enum value.
`MemberModel` `findMemberModelByC2jName(String memberC2jName)` Returns the member model associated with the given c2j member name from this shape model.
`List<ConstructorModel>` `getAdditionalConstructors()`
`String` `getC2jName()`
`ShapeCustomizationInfo` `getCustomization()`
`List<EnumModel>` `getEnums()`
`String` `getErrorCode()`
`ShapeMarshaller` `getMarshaller()`
`MemberModel` `getMemberByC2jName(String memberName)`
`MemberModel` `getMemberByName(String memberName)`
`MemberModel` `getMemberByVariableName(String memberVariableName)`
`List<MemberModel>` `getMembers()`
`Map<String,MemberModel>` `getMembersAsMap()`
`MemberModel` `getPayloadMember()`
`List<String>` `getRequired()`
`String` `getShapeName()`
`ShapeType` `getShapeType()`
`String` `getType()`
`List<MemberModel>` `getUnboundMembers()`
`ShapeUnmarshaller` `getUnmarshaller()`
`VariableModel` `getVariable()`
`boolean` `isDeprecated()`
`boolean` `isHasHeaderMember()`
`boolean` `isHasPayloadMember()`
`boolean` `isHasStatusCodeMember()`
`boolean` `isHasStreamingMember()`
`boolean` `isWrapper()`
`boolean` `removeMemberByC2jName(String memberC2jName, boolean ignoreCase)` Takes in the c2j member name as input and removes if the shape contains a member with the given name.
`void` `setAdditionalConstructors(List<ConstructorModel> additionalConstructors)`
`void` `setCustomization(ShapeCustomizationInfo customization)`
`void` `setDeprecated(boolean deprecated)`
`void` `setEnums(List<EnumModel> enums)`
`void` `setErrorCode(String errorCode)`
`void` `setHasHeaderMember(boolean hasHeaderMember)`
`void` `setHasPayloadMember(boolean hasPayloadMember)`
`void` `setHasStatusCodeMember(boolean hasStatusCodeMember)`
`void` `setHasStreamingMember(boolean hasStreamingMember)`
`void` `setMarshaller(ShapeMarshaller marshaller)`
`void` `setMembers(List<MemberModel> members)`
`void` `setRequired(List<String> required)`
`void` `setShapeName(String shapeName)`
`void` `setType(ShapeType shapeType)`
`void` `setType(String type)`
`void` `setUnmarshaller(ShapeUnmarshaller unmarshaller)`
`void` `setVariable(VariableModel variable)`
`void` `setWrapper(boolean wrapper)`
`String` `toString()`
`ShapeModel` `withHasHeaderMember(boolean hasHeaderMember)`
`ShapeModel` `withHasPayloadMember(boolean hasPayloadMember)`
`ShapeModel` `withHasStatusCodeMember(boolean hasStatusCodeMember)`
`ShapeModel` `withHasStreamingMember(boolean hasStreamingMember)`
`ShapeModel` `withType(String type)`

### Methods inherited from class com.amazonaws.codegen.model.intermediate.DocumentationModel

`getDocumentation, setDocumentation`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Constructor Detail

#### ShapeModel

    public ShapeModel(String c2jName)

### Method Detail

#### getShapeName

    public String getShapeName()

#### setShapeName

    public void setShapeName(String shapeName)

#### isDeprecated

    public boolean isDeprecated()

#### setDeprecated

    public void setDeprecated(boolean deprecated)

#### getC2jName

    public String getC2jName()

#### getType

    public String getType()

#### getShapeType

    public ShapeType getShapeType()

#### setType

    public void setType(ShapeType shapeType)

#### setType

    public void setType(String type)

#### withType

    public ShapeModel withType(String type)

#### getRequired

    public List<String> getRequired()

#### setRequired

    public void setRequired(List<String> required)

#### isHasPayloadMember

    public boolean isHasPayloadMember()

#### setHasPayloadMember

    public void setHasPayloadMember(boolean hasPayloadMember)

#### withHasPayloadMember

    public ShapeModel withHasPayloadMember(boolean hasPayloadMember)

#### getPayloadMember

    public MemberModel getPayloadMember()

Returns:
  The member explicitly designated as the payload member

#### getUnboundMembers

    public List<MemberModel> getUnboundMembers()

Returns:
  The list of members whose location is not specified. If no payload member is explicitly set then these members will appear in the payload

#### isHasStreamingMember

    public boolean isHasStreamingMember()

#### setHasStreamingMember

    public void setHasStreamingMember(boolean hasStreamingMember)

#### withHasStreamingMember

    public ShapeModel withHasStreamingMember(boolean hasStreamingMember)

#### isHasHeaderMember

    public boolean isHasHeaderMember()

#### setHasHeaderMember

    public void setHasHeaderMember(boolean hasHeaderMember)

#### withHasHeaderMember

    public ShapeModel withHasHeaderMember(boolean hasHeaderMember)

#### isHasStatusCodeMember

    public boolean isHasStatusCodeMember()

#### setHasStatusCodeMember

    public void setHasStatusCodeMember(boolean hasStatusCodeMember)

#### isWrapper

    public boolean isWrapper()

#### setWrapper

    public void setWrapper(boolean wrapper)

#### withHasStatusCodeMember

    public ShapeModel withHasStatusCodeMember(boolean hasStatusCodeMember)

#### getMemberByVariableName

    public MemberModel getMemberByVariableName(String memberVariableName)

#### getMemberByName

    public MemberModel getMemberByName(String memberName)

#### getMemberByC2jName

    public MemberModel getMemberByC2jName(String memberName)

#### getMembers

    public List<MemberModel> getMembers()

#### setMembers

    public void setMembers(List<MemberModel> members)

#### addMember

    public void addMember(MemberModel member)

#### getAdditionalConstructors

    public List<ConstructorModel> getAdditionalConstructors()

#### setAdditionalConstructors

    public void setAdditionalConstructors(List<ConstructorModel> additionalConstructors)

#### addConstructor

    public void addConstructor(ConstructorModel constructor)

#### getEnums

    public List<EnumModel> getEnums()

#### setEnums

    public void setEnums(List<EnumModel> enums)

#### addEnum

    public void addEnum(EnumModel enumModel)

#### getVariable

    public VariableModel getVariable()

#### setVariable

    public void setVariable(VariableModel variable)

#### getMarshaller

    public ShapeMarshaller getMarshaller()

#### setMarshaller

    public void setMarshaller(ShapeMarshaller marshaller)

#### getUnmarshaller

    public ShapeUnmarshaller getUnmarshaller()

#### setUnmarshaller

    public void setUnmarshaller(ShapeUnmarshaller unmarshaller)

#### getCustomization

    public ShapeCustomizationInfo getCustomization()

#### setCustomization

    public void setCustomization(ShapeCustomizationInfo customization)

#### getMembersAsMap

    public Map<String,MemberModel> getMembersAsMap()

#### findMemberModelByC2jName

    public MemberModel findMemberModelByC2jName(String memberC2jName)

Returns the member model associated with the given c2j member name from this shape model.

#### removeMemberByC2jName

    public boolean removeMemberByC2jName(String memberC2jName,
                                         boolean ignoreCase)

Takes in the c2j member name as input and removes if the shape contains a member with the given name. Return false otherwise.

#### findEnumModelByValue

    public EnumModel findEnumModelByValue(String enumValue)

Returns the enum model for the given enum value. Returns null if no such enum value exists.

#### toString

    public String toString()

Overrides:
  `toString` in class `Object`

#### getErrorCode

    public String getErrorCode()

#### setErrorCode

    public void setErrorCode(String errorCode)